part of pdf;

/// Represents the Uri annotation.
class PdfUriAnnotation extends PdfActionLinkAnnotation {
  // constructor
  /// Initializes a new instance of the [PdfUriAnnotation] class with specified bounds and Uri.
  PdfUriAnnotation({@required Rect bounds, String uri}) : super(bounds) {
    ArgumentError.checkNotNull(uri, 'uri');
    this.uri = uri;
  }

  // fields
  String _uri = '';
  final PdfUriAction _uriAction = PdfUriAction();

  // properties
  /// Gets the Uri address.
  String get uri => _uri;

  /// Sets the Uri address.
  set uri(String value) {
    ArgumentError.checkNotNull(value, 'uri');
    _uri = value;
    if (_uriAction.uri != value) {
      _uriAction.uri = value;
    }
  }

  @override

  /// Gets the action.
  PdfAction get action => super.action;

  /// Sets the action.
  set action(PdfAction value) {
    super.action = value;
    _uriAction.next = value;
  }

  // implementation
  @override
  void _initialize() {
    super._initialize();
    _dictionary.setProperty(_PdfName(_DictionaryProperties.subtype),
        _PdfName(_DictionaryProperties.link));
    _dictionary.setProperty(_PdfName(_DictionaryProperties.a),
        _uriAction._element ??= _uriAction._dictionary);
  }

  @override
  _IPdfPrimitive _element;
}
